/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.plugin.geoloc.dataimport.geoname;

/**
 *
 * @author sglon
 */
public final class GeonameFormat {

    private GeonameFormat() {
    }

    /**
     * geonameid : integer id of record in geonames database
     */
    public static final int GEONAME_ID = 0;

    /**
     * name : name of geographical point (utf8) varchar(200)
     */
    public static final int NAME = 1;

    /**
     * asciiname : name of geographical point in plain ascii characters,
     * varchar(200)
     */
    public static final int ASCII_NAME = 2;

    /**
     * alternatenames : alternatenames, comma separated varchar(5000)
     */
    public static final int ALTERNATE_NAMES = 3;

    /**
     * latitude : latitude in decimal degrees (wgs84)
     */
    public static final int LATITUDE = 4;

    /**
     * longitude : longitude in decimal degrees (wgs84)
     */
    public static final int LONGITUDE = 5;

    /**
     * feature class : see http://www.geonames.org/export/codes.html, char(1)
     */
    public static final int FEATURE_CLASS = 6;

    /**
     * feature code : see http://www.geonames.org/export/codes.html, varchar(10)
     */
    public static final int FEATURE_CODE = 7;

    /**
     * country code : ISO-3166 2-letter country code, 2 characters
     */
    public static final int COUNTRY_CODE = 8;

    /**
     * cc2 : alternate country codes, comma separated, ISO-3166 2-letter country
     * code, 60 characters
     */
    public static final int CC2 = 9;

    /**
     * admin1 code : fipscode (subject to change to iso code), see exceptions
     * below, see file admin1Codes.txt for display names of this code;
     * varchar(20)
     */
    public static final int ADM1 = 10;

    /**
     * admin2 code : code for the second administrative division, a county in
     * the US, see file admin2Codes.txt; varchar(80)
     */
    public static final int ADM2 = 11;

    /**
     * admin3 code : code for third level administrative division, varchar(20)
     */
    public static final int ADM3 = 12;

    /**
     * admin4 code : code for fourth level administrative division, varchar(20)
     */
    public static final int ADM4 = 13;

    /**
     * population : bigint (8 byte int)
     */
    public static final int POPULATION = 14;

    /**
     * elevation : in meters, integer
     */
    public static final int ALTITUDE = 15;

    /**
     * dem : digital elevation model, srtm3 or gtopo30, average elevation of
     * 3''x3'' (ca 90mx90m) or 30''x30'' (ca 900mx900m) area in meters, integer
     * timezone : the timezone id (see file timeZone.txt)
     */
    public static final int DEM = 16;

    /**
     * modification date : date of last modification in yyyy-MM-dd format
     */
    public static final int MODIFICATION_DATE = 17;

    /**
     * Nbr de colonne du fichier.
     */
    public static final int SIZE_COLUMN_FILE = 17;
}
